class DataCase implements Comparable {
  
  Map values;
  Point[] points;
  color colour;
  int drawOrder;
  
  DataCase(int numDimensions) {
    values = new HashMap();
    points = new Point[numDimensions];
    for (int i = 0; i < points.length; i++) {
      points[i] = new Point();
    }
    drawOrder = 0;
  }
  
  void setValue(String axisLabel, String value) {
    values.put(axisLabel, value);
  }
  
  String getValue(String axisLabel) {
     return (String) values.get(axisLabel);
  }
  
  void draw(int percentageOpactity) {
    stroke(colour, map(percentageOpactity, 0, 100, 0, 255));
    strokeWeight(1);
    for (int i = 0; i < (points.length - 1); i++) {
      line(points[i].x, points[i].y, points[(i + 1)].x, points[(i + 1)].y);
    }
  }
  
  int compareTo(Object obj) {
    return drawOrder;
  }
  
  boolean intersectedBy(Point startPoint, Point endPoint) {
    for (int i = 0; i < points.length - 1; i++) {
      if (intersect(startPoint.x, startPoint.y, endPoint.x, endPoint.y, points[i].x, points[i].y, points[(i + 1)].x, points[(i + 1)].y)) return true;
    }
    return false;
  }
  
  boolean intersect(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
    // modified from code taken from http://www.ecole-art-aix.fr/article425.html
    float a1, a2, b1, b2, c1, c2;
    float r1, r2 , r3, r4;
    a1 = y2 - y1;
    b1 = x1 - x2;
    c1 = (x2 * y1) - (x1 * y2);
    r3 = ((a1 * (float) x3) + (b1 * (float) y3) + c1);
    r4 = ((a1 * (float) x4) + (b1 * (float) y4) + c1);
    if ((r3 != 0) && (r4 != 0) && ((r3 * r4) >= 0)) return false;
    a2 = y4 - y3;
    b2 = x3 - x4;
    c2 = (x4 * y3) - (x3 * y4);
    r1 = (a2 * (float) x1) + (b2 * (float) y1) + c2;
    r2 = (a2 * (float) x2) + (b2 * (float) y2) + c2;
    if ((r1 != 0) && (r2 != 0) && ((r1 * r2) >= 0)) return false;
    return true;
  }
}
