class RangeBar {
  
  int x, startY, endY, minY, maxY, dragPoint, width, cordLength, deleteBoxWidth;
  boolean selected, resizing;
  color colour;
  
  RangeBar(int x, int startY, int endY, int minY, int maxY, color colour, color axisColour) {
    this.x = x;
    this.startY = startY;
    this.endY = endY;
    this.minY = minY;
    this.maxY = maxY;
    this.colour = colour;
    selected = false;
    resizing = false;
    config();
  }
  
  void config() {
    width = 10;
    cordLength = 7;
    deleteBoxWidth = 8;
  }
  
  boolean hover() {
    return (mouseX >= x - width && mouseX <= x && mouseY >= startY && mouseY <= endY);
  }
  
  void draw(boolean allowHover) {
    strokeWeight(1);
    if (startY != endY) {
      fill(colour);
      if (selected || (allowHover && hover())) {
        stroke(axisColour);
        rect(x - width, startY, width, endY - startY);
      } else {
        stroke(colour);
        rect(x - width, startY, width - 1, endY - startY);
      }
    } else {
      if (selected || (allowHover && hover())) {
        stroke(axisColour);
      } else {
        stroke(colour);
      }
      line(x - width, startY, x - 1, endY);
    }
  }
  
  void drawEditingComponents() {
    strokeWeight(1);
    stroke(axisColour);
    fill(axisColour);
    line(x - (width / 2), startY, x - (width / 2), startY - cordLength);
    ellipse(x - (width / 2), startY - cordLength, width / 2, width / 2);
    line(x - (width / 2), endY, x - (width / 2), endY + cordLength);
    ellipse(x - (width / 2), endY + cordLength, width / 2, width / 2);
  }
  
  void drawDeleteBox() {
    int y = startY + ((endY - startY) / 2);
    strokeWeight(1);
    stroke(axisColour);
    noFill();
    rect(x - (width + deleteBoxWidth), y - (deleteBoxWidth / 2), deleteBoxWidth, deleteBoxWidth);
    line(x - (width + deleteBoxWidth), y - (deleteBoxWidth / 2), x - width, y + (deleteBoxWidth / 2));
    line(x - (width + deleteBoxWidth), y + (deleteBoxWidth / 2), x - width, y - (deleteBoxWidth / 2));
  }
  
  boolean deleteBoxHover() {
    int y = startY + ((endY - startY) / 2);
    return (mouseX >= x - (width + deleteBoxWidth) && mouseX <= x - width && mouseY >= y - (deleteBoxWidth / 2) && mouseY <= y + (deleteBoxWidth / 2));
  }
  
  boolean topHandleHover() {
    return (dist(mouseX, mouseY, x - (width / 2), startY - cordLength) <= width / 2);
  }
  
  boolean bottomHandleHover() { 
    return (dist(mouseX, mouseY, x - (width / 2), endY + cordLength) <= width / 2);
  }
}
