class Table {
  
  int numCases;
  float min, max;
  String name, type, order;
  String[] possibleValues;
  String[][] data;
  
  Table(String filename, boolean metaDataOnly) {
    String[] rows = loadStrings(filename);
    if (rows.length > 0 && rows[0].startsWith("#")) {
      String[] metaData = split(rows[0], TAB);
      name = metaData[0].replaceAll("#", "");
      type = metaData[1];
      numCases = int(metaData[2].replaceAll("cases=", ""));
      if (type.equals("seconds") || type.equals("int") || type.equals("float")) {
        min = float(metaData[3].replaceAll("min=", ""));
        max = float(metaData[4].replaceAll("max=", ""));
        order = metaData[5].replaceAll("order=", "");
      } else if (type.equals("string")) {
        possibleValues = split(metaData[3], '|');
      }
      if (!metaDataOnly) {
        data = new String[numCases][];
      }
    } else if (!metaDataOnly) {
      data = new String[rows.length][];
    }
    if (!metaDataOnly) {
      int rowCount = 0;
      for (int i = 0; i < rows.length; i++) {
        if (trim(rows[i]).length() == 0) {
          continue; // skip empty rows
        }
        if (rows[i].startsWith("#")) {
          continue;  // skip comment lines
        }
        data[rowCount++] = split(rows[i], TAB);
      }
    }
  }
}
